// Copyright 2024 MaidSafe.net limited.
//
// This SAFE Network Software is licensed to you under The General Public License (GPL), version 3.
// Unless required by applicable law or agreed to in writing, the SAFE Network Software distributed
// under the GPL Licence is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied. Please review the Licences for the specific language governing
// permissions and limitations relating to use of the SAFE Network Software.

use alloy::primitives::FixedBytes;

pub type Address = alloy::primitives::Address;
pub type Hash = FixedBytes<32>;
pub type TxHash = alloy::primitives::TxHash;
pub type U256 = alloy::primitives::U256;
pub type QuoteHash = Hash;
pub type Amount = U256;
pub type QuotePayment = (QuoteHash, Address, Amount);
pub type EthereumWallet = alloy::network::EthereumWallet;
pub type Calldata = alloy::primitives::Bytes;
